/*
 * A n t l r  T r a n s l a t i o n  H e a d e r
 *
 * Terence Parr, Hank Dietz and Will Cohen: 1989-1992
 * Purdue University Electrical Engineering
 * ANTLR Version 1.06
 */
#include <stdio.h>
#include <ctype.h>
#include "dlg.h"
#ifdef MEMCHK
#include "trax.h"
#else
extern char *malloc();
extern char *calloc();
#endif
#include "antlr.h"
#include "tokens.h"
#include "dlgdef.h"
#include "mode.h"
ANTLR_INFO
int	action_no = 0;	   /* keep track of actions outputed */
int	nfa_allocated = 0; /* keeps track of number of nfa nodes */
nfa_node *nfa_array = NULL;/* root of binary tree that stores nfa array */
nfa_node nfa_model_node;   /* model to initialize new nodes */
set	used_chars;	   /* used to label trans. arcs */
set	used_classes;	   /* classes or chars used to label trans. arcs */
set	normal_chars;	   /* mask to get rid elements that aren't used
in set */
int	flag_paren = FALSE;
int	flag_brace = FALSE;
int	mode_counter = 0;  /* keep track of number of %%names */

#ifdef __STDC__
void
grammar()
#else
grammar()
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	p_head(); func_action = FALSE;  
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==ACTION) ) {
			zzmatch(ACTION); zzCONSUME;
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	start_states();
	func_action = FALSE; p_tables(); p_tail();   
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==ACTION) ) {
			zzmatch(ACTION); zzCONSUME;
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(1); zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, "", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x1);
	}
}

#ifdef __STDC__
void
start_states()
#else
start_states()
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		if ( (LA(1)==PER_PER) ) {
			zzmatch(PER_PER); zzCONSUME;
			do_conversion();
		}
		else if ( (LA(1)==NAME_PER_PER) ) {
			zzmatch(NAME_PER_PER); zzCONSUME;
			do_conversion();
			{
				zzBLOCK(zztasp3);
				zzMake0;
				{
				while ( (LA(1)==NAME_PER_PER) ) {
					zzmatch(NAME_PER_PER); zzCONSUME;
					do_conversion();
					zzLOOP(zztasp3);
				}
				zzEXIT(zztasp3);
				}
			}
		}
		else {zzFAIL(1,zzerr1,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(PER_PER); zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, "", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x2);
	}
}

#ifdef __STDC__
void
do_conversion()
#else
do_conversion()
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	new_automaton_mode(); func_action = TRUE;  
	rule_list();
	dfa_class_nop[mode_counter] =
	relabel(zzaArg(zztasp1,1 ).l,comp_level);
	if (comp_level)
	p_shift_table(mode_counter);
	dfa_basep[mode_counter] = dfa_allocated+1;
	make_dfa_model_node(dfa_class_nop[mode_counter]);
	nfa_to_dfa(zzaArg(zztasp1,1 ).l);
	++mode_counter;
	func_action = FALSE;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, "", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x4);
	}
}

#ifdef __STDC__
void
rule_list()
#else
rule_list()
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	if ( (setwd1[LA(1)]&0x8) ) {
		rule();
		zzaRet.l=zzaArg(zztasp1,1 ).l; zzaRet.r=zzaArg(zztasp1,1 ).r;  
		{
			zzBLOCK(zztasp2);
			zzMake0;
			{
			while ( (setwd1[LA(1)]&0x10) ) {
				rule();
				{nfa_node *t1;
					t1 = new_nfa_node();
					(t1)->trans[0]=zzaRet.l;
					(t1)->trans[1]=zzaArg(zztasp2,1 ).l;
					/* all accept nodes "dead ends" */
					zzaRet.l=t1; zzaRet.r=NULL;
				}
				zzLOOP(zztasp2);
			}
			zzEXIT(zztasp2);
			}
		}
	}
	else if ( (setwd1[LA(1)]&0x20) ) {
		zzaRet.l = new_nfa_node(); zzaRet.r = NULL;
		warning("no regular expressions", zzline);
	}
	else {zzFAIL(1,zzerr2,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, "", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x40);
	}
}

#ifdef __STDC__
void
rule()
#else
rule()
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	if ( (setwd1[LA(1)]&0x80) ) {
		reg_expr();
		zzmatch(ACTION);
		zzaRet.l=zzaArg(zztasp1,1 ).l; zzaRet.r=zzaArg(zztasp1,1 ).r; (zzaArg(zztasp1,1 ).r)->accept=action_no;  
		 zzCONSUME;
	}
	else if ( (LA(1)==ACTION) ) {
		zzmatch(ACTION);
		zzaRet.l = NULL; zzaRet.r = NULL;
		error("no expression for action  ", zzline);
		 zzCONSUME;
	}
	else {zzFAIL(1,zzerr3,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, "", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x100);
	}
}

#ifdef __STDC__
void
reg_expr()
#else
reg_expr()
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	and_expr();
	zzaRet.l=zzaArg(zztasp1,1 ).l; zzaRet.r=zzaArg(zztasp1,1 ).r;  
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==OR) ) {
			zzmatch(OR); zzCONSUME;
			and_expr();
			{nfa_node *t1, *t2;
				t1 = new_nfa_node(); t2 = new_nfa_node();
				(t1)->trans[0]=zzaRet.l;
				(t1)->trans[1]=zzaArg(zztasp2,2 ).l;
				(zzaRet.r)->trans[1]=t2;
				(zzaArg(zztasp2,2 ).r)->trans[1]=t2;
				zzaRet.l=t1; zzaRet.r=t2;
			}
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, "", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x200);
	}
}

#ifdef __STDC__
void
and_expr()
#else
and_expr()
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	repeat_expr();
	zzaRet.l=zzaArg(zztasp1,1 ).l; zzaRet.r=zzaArg(zztasp1,1 ).r;  
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (setwd1[LA(1)]&0x400) ) {
			repeat_expr();
			(zzaRet.r)->trans[1]=zzaArg(zztasp2,1 ).l; zzaRet.r=zzaArg(zztasp2,1 ).r;  
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, "", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x800);
	}
}

#ifdef __STDC__
void
repeat_expr()
#else
repeat_expr()
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	if ( (setwd1[LA(1)]&0x1000) ) {
		expr();
		zzaRet.l=zzaArg(zztasp1,1 ).l; zzaRet.r=zzaArg(zztasp1,1 ).r;  
		{
			zzBLOCK(zztasp2);
			zzMake0;
			{
			if ( (LA(1)==ZERO_MORE) ) {
				zzmatch(ZERO_MORE);
				{	nfa_node *t1,*t2;
					(zzaRet.r)->trans[0] = zzaRet.l;
					t1 = new_nfa_node(); t2 = new_nfa_node();
					t1->trans[0]=zzaRet.l;
					t1->trans[1]=t2;
					(zzaRet.r)->trans[1]=t2;
					zzaRet.l=t1;zzaRet.r=t2;
				}
				 zzCONSUME;
			}
			else if ( (LA(1)==ONE_MORE) ) {
				zzmatch(ONE_MORE);
				(zzaRet.r)->trans[0] = zzaRet.l;  
				 zzCONSUME;
			}
			zzEXIT(zztasp2);
			}
		}
	}
	else if ( (LA(1)==ZERO_MORE) ) {
		zzmatch(ZERO_MORE);
		error("no expression for *", zzline);  
		 zzCONSUME;
	}
	else if ( (LA(1)==ONE_MORE) ) {
		zzmatch(ONE_MORE);
		error("no expression for +", zzline);  
		 zzCONSUME;
	}
	else {zzFAIL(1,zzerr4,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, "", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x2000);
	}
}

#ifdef __STDC__
void
expr()
#else
expr()
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	if ( (LA(1)==L_BRACK) ) {
		zzmatch(L_BRACK); zzCONSUME;
		atom_list();
		zzmatch(R_BRACK);
		zzaRet.l = new_nfa_node(); zzaRet.r = new_nfa_node();
		(zzaRet.l)->trans[0] = zzaRet.r;
		(zzaRet.l)->label = set_dup(zzaArg(zztasp1,2 ).label);
		set_orin(&used_chars,(zzaRet.l)->label);
		 zzCONSUME;
	}
	else if ( (LA(1)==NOT) ) {
		zzmatch(NOT); zzCONSUME;
		zzmatch(L_BRACK); zzCONSUME;
		atom_list();
		zzmatch(R_BRACK);
		zzaRet.l = new_nfa_node(); zzaRet.r = new_nfa_node();
		(zzaRet.l)->trans[0] = zzaRet.r;
		(zzaRet.l)->label = set_dif(normal_chars,zzaArg(zztasp1,3 ).label);
		set_orin(&used_chars,(zzaRet.l)->label);
		 zzCONSUME;
	}
	else if ( (LA(1)==L_PAR) ) {
		zzmatch(L_PAR); zzCONSUME;
		reg_expr();
		zzmatch(R_PAR);
		zzaRet.l = new_nfa_node(); zzaRet.r = new_nfa_node();
		(zzaRet.l)->trans[0] = zzaArg(zztasp1,2 ).l;
		(zzaArg(zztasp1,2 ).r)->trans[1] = zzaRet.r;
		 zzCONSUME;
	}
	else if ( (LA(1)==L_BRACE) ) {
		zzmatch(L_BRACE); zzCONSUME;
		reg_expr();
		zzmatch(R_BRACE);
		zzaRet.l = new_nfa_node(); zzaRet.r = new_nfa_node();
		(zzaRet.l)->trans[0] = zzaArg(zztasp1,2 ).l;
		(zzaRet.l)->trans[1] = zzaRet.r;
		(zzaArg(zztasp1,2 ).r)->trans[1] = zzaRet.r;
		 zzCONSUME;
	}
	else if ( (setwd1[LA(1)]&0x4000) ) {
		atom();
		zzaRet.l = new_nfa_node(); zzaRet.r = new_nfa_node();
		(zzaRet.l)->trans[0] = zzaRet.r;
		(zzaRet.l)->label = set_dup(zzaArg(zztasp1,1 ).label);
		set_orin(&used_chars,(zzaRet.l)->label);
	}
	else {zzFAIL(1,zzerr5,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, "", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x8000);
	}
}

#ifdef __STDC__
void
atom_list()
#else
atom_list()
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	set_free(zzaRet.label);   
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (setwd2[LA(1)]&0x1) ) {
			near_atom();
			set_orin(&(zzaRet.label),zzaArg(zztasp2,1 ).label);  
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, "", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd2, 0x2);
	}
}

#ifdef __STDC__
void
near_atom()
#else
near_atom()
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	register int i;
	register int i_prime;
	anychar();
	zzaRet.letter=zzaArg(zztasp1,1 ).letter; zzaRet.label=set_of(zzaArg(zztasp1,1 ).letter);
	i_prime = zzaArg(zztasp1,1 ).letter + MIN_CHAR;
	if (case_insensitive && islower(i_prime))
	set_orel(toupper(i_prime)-MIN_CHAR,
	&(zzaRet.label));
	if (case_insensitive && isupper(i_prime))
	set_orel(tolower(i_prime)-MIN_CHAR,
	&(zzaRet.label));
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		if ( (LA(1)==RANGE) ) {
			zzmatch(RANGE); zzCONSUME;
			anychar();
			for (i=zzaRet.letter; i<= zzaArg(zztasp2,2 ).letter; ++i){
				set_orel(i,&(zzaRet.label));
				i_prime = i+MIN_CHAR;
				if (case_insensitive && islower(i_prime))
				set_orel(toupper(i_prime)-MIN_CHAR,
				&(zzaRet.label));
				if (case_insensitive && isupper(i_prime))
				set_orel(tolower(i_prime)-MIN_CHAR,
				&(zzaRet.label));
			}
		}
		zzEXIT(zztasp2);
		}
	}
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, "", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd2, 0x4);
	}
}

#ifdef __STDC__
void
atom()
#else
atom()
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	register int i_prime;  
	anychar();
	zzaRet.label = set_of(zzaArg(zztasp1,1 ).letter);
	i_prime = zzaArg(zztasp1,1 ).letter + MIN_CHAR;
	if (case_insensitive && islower(i_prime))
	set_orel(toupper(i_prime)-MIN_CHAR,
	&(zzaRet.label));
	if (case_insensitive && isupper(i_prime))
	set_orel(tolower(i_prime)-MIN_CHAR,
	&(zzaRet.label));
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, "", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd2, 0x8);
	}
}

#ifdef __STDC__
void
anychar()
#else
anychar()
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	if ( (LA(1)==REGCHAR) ) {
		zzmatch(REGCHAR);
		zzaRet.letter = zzaArg(zztasp1,1 ).letter - MIN_CHAR;  
		 zzCONSUME;
	}
	else if ( (LA(1)==OCTAL_VALUE) ) {
		zzmatch(OCTAL_VALUE);
		zzaRet.letter = zzaArg(zztasp1,1 ).letter - MIN_CHAR;  
		 zzCONSUME;
	}
	else if ( (LA(1)==HEX_VALUE) ) {
		zzmatch(HEX_VALUE);
		zzaRet.letter = zzaArg(zztasp1,1 ).letter - MIN_CHAR;  
		 zzCONSUME;
	}
	else if ( (LA(1)==DEC_VALUE) ) {
		zzmatch(DEC_VALUE);
		zzaRet.letter = zzaArg(zztasp1,1 ).letter - MIN_CHAR;  
		 zzCONSUME;
	}
	else if ( (LA(1)==TAB) ) {
		zzmatch(TAB);
		zzaRet.letter = zzaArg(zztasp1,1 ).letter - MIN_CHAR;  
		 zzCONSUME;
	}
	else if ( (LA(1)==NL) ) {
		zzmatch(NL);
		zzaRet.letter = zzaArg(zztasp1,1 ).letter - MIN_CHAR;  
		 zzCONSUME;
	}
	else if ( (LA(1)==CR) ) {
		zzmatch(CR);
		zzaRet.letter = zzaArg(zztasp1,1 ).letter - MIN_CHAR;  
		 zzCONSUME;
	}
	else if ( (LA(1)==BS) ) {
		zzmatch(BS);
		zzaRet.letter = zzaArg(zztasp1,1 ).letter - MIN_CHAR;  
		 zzCONSUME;
	}
	else if ( (LA(1)==LIT) ) {
		zzmatch(LIT);
		zzaRet.letter = zzaArg(zztasp1,1 ).letter - MIN_CHAR;  
		 zzCONSUME;
	}
	else if ( (LA(1)==L_EOF) ) {
		zzmatch(L_EOF);
		zzaRet.letter = 0;  
		 zzCONSUME;
	}
	else {zzFAIL(1,zzerr6,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	/* empty action */  
	zzsyn(zzMissText, zzBadTok, "", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd2, 0x10);
	}
}
/* finds nfa state i in the binary tree nfa_array */
nfa_node *index_nfa(i)
register int i;
{
	register nfa_node *p = nfa_array;
	if (i){
		while((i>1) && p){
			if(i & 1)
			p = p->right;
			else
			p = p->left;
			i = i>>1;
		}
		return p;
	}else{
		return NIL_INDEX;
	}
}
/* adds a new nfa to the binary tree and returns a pointer to it */
nfa_node *new_nfa_node()
{
	register nfa_node *p = nfa_array;
	nfa_node *t;
	register int i;
	i = ++nfa_allocated;
	t = (nfa_node*) malloc(sizeof(nfa_node));
	*t = nfa_model_node;
	t->node_no = i;
	while((i>3) && p){
		if(i & 1)
		p = p->right;
		else
		p = p->left;
		i = i>>1;
	}
	if (nfa_allocated == 1)
	nfa_array = t;
	else if (p != NIL_INDEX){
		if (i & 1)
		p->right = t;
		else
		p->left = t;
	}
	else{
		internal_error("%s(%d): missing node on binary tree\n",
		__FILE__,__LINE__);
	}
	return t;
}
/* initialize the model node used to fill in newly made nfa_nodes */
make_nfa_model_node()
{
	nfa_model_node.left = NULL;
	nfa_model_node.right = NULL;
	nfa_model_node.node_no = -1; /* impossible value for real nfa node */
	nfa_model_node.nfa_set = 0;
	nfa_model_node.accept = 0;   /* error state default*/
	nfa_model_node.trans[0] = NULL;
	nfa_model_node.trans[1] = NULL;
	nfa_model_node.label = empty;
}
